#ifndef __NODE_H__
#define __NODE_H__

#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

#define OUT 0
#define IN 1


class Node{
private:
	vector<Node*> inNodes;
	vector<Node*> outNodes;
	int id;
	int initTime;
	int finishTime;
public:

	Node(int id){
		this->id = id;
		initTime = -1;
		finishTime = -1;
	}

	void addNeighbour(Node* neighbour, int neighbourType){
		getList(neighbourType)->push_back(neighbour);
	}
	
	int removeNeighbour(Node* neighbour, int neighbourType){
		vector<Node*>* list = getList(neighbourType);
		for(vector<Node*>::iterator it = list->begin(); it != list->end(); ++it){
			if ( (*it)->getId() == neighbour->getId() ){
				getList(neighbourType)->erase(it);
				return true;
			}
		}
		return false;
	}

	int isRootNode(){
		return inNodes.empty();
	}
	
	int getId() {
		return this->id;
	}
	
	vector<Node*> getInNodes() {
		return inNodes;
	}

	vector<Node*> getOutNodes() {
		return outNodes;
	}

	void print(){
		cout << id << " - ";
		for(vector<Node*>::iterator it = outNodes.begin(); it != outNodes.end(); ++it){
			cout << (*it)->getId() << " ";
		}
		cout << "\n";
	}

	void setFinishTime(int time) {
		finishTime = time;
	}

	void setInitTime(int time) {
		initTime = time;
	}

	int getInitTime() {
		return initTime;
	}

	int getFinishTime() {
		return finishTime;
	}


private:
	vector<Node*>* getList(int listType){
		if ( listType == IN ){
			return &inNodes;			
		} else {
			return &outNodes;
		}
	}
	
};

#endif